CON

{{SidPlayer v. 0.06 ALPHA}}

  _clkmode = xtal1+pll16x
  '_clkfreq = 117_964_800
  '_clkfreq = 100_000_000
  _clkfreq = 80_000_000

  _SD_DO = 0
  _SD_CLK = 1
  _SD_DI = 2
  _SD_CS = 3
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.



  rightPin = 10
  leftPin  = 11

var
byte cmdbuf[81]
byte cmdbuf2[81]
byte cptr
byte buffer2[25]
byte namebuf[300*32]
long pos
long playrate
long il
long disp_pos
long disp_start
long playcog
long playstack[128]
long time
long wait
long stop

OBJ

  kbm           : "kbm"
  vga           : "vn2032-20120613"
  fat           : "kyefat"
  sid           : "sidcog"

pub start | char, mx, my, dmx,dmy, buffer, i, code,s1,s2,g,j,l,x,y

playcog:=-1

s2:=string("Scanning...")
s1:=string("SidPlay v. 0.06 Alpha --- 2012.06.15")

' start components

kbm.start(24,25,26,27)
vga.start
sid.start(rightPin, leftPin)
fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)
vga.cursoroff

'wait until they starts...

waitcnt(clkfreq*3 + cnt)


'mount a SD

vga.writeln(string("Mounting SD card. Check SD card, reset your board if this text don't disappear"))
waitcnt(clkfreq+cnt)
fat.mountPartition(0)
vga.cls
vga.cursoroff
waitcnt(clkfreq*3+cnt)

\fat.changedirectory(string("dmp"))

vga.outtextxy (40-(strsize(s1)>>1),0,s1)  'need to add function for centered text to VGA driver
repeat i from 5 to 15
  vga.setfontcolor(0,i,0,3,0)             'need to add colored text output function

vga.outtextxy(34,1,s2)
repeat i from 5 to 15
  vga.setfontcolor(1,i,3,0,0)

il:=scan-1



' we have scanned directory here

vga.box(40,2,79,29)
repeat j from 2 to 29
  repeat i from 10 to 19
    vga.setbackcolor(j,i,1,0,0)

vga.putchar(59,2,7)
vga.putchar(73,2,8)
vga.outtextxy(60,2,string(" Media files "))

vga.box(0,2,39,19)
repeat j from 2 to 19
  repeat i from 0 to 9
    vga.setbackcolor(j,i,0,1,0)

vga.putchar(19,2,7)
vga.putchar(33,2,8)
vga.outtextxy(20,2,string(" Directories "))

vga.box(0,20,39,29)
repeat j from 20 to 29
  repeat i from 0 to 9
    vga.setbackcolor(j,i,1,1,0)

vga.putchar(19,20,7)
vga.putchar(33,20,8)
vga.outtextxy(20,20,string(" Now playing "))

pos:=0
disp_pos:=0
disp_start:=0
display
setdmpdisplay(0)

repeat i from 1 to 8
  vga.setfontcolor(28,i,3,2,2)
vga.outtextxy(16,28,string("00:00:00            "))
repeat i from 1 to 8
  vga.setfontcolor(23,i,3,3,0)
  vga.setfontcolor(25,i,3,3,0)
  vga.setfontcolor(27,i,3,3,0)
'stop:=1
repeat
  displaytime(time)

  if char:=kbm.key
    if char==$c3
      setdmpdisplay(1)

    if char==$c2
      setdmpdisplay(-1)

    if char==13
      if playcog==-1
        playcog:=cognew(playcmd,@playstack)
      else
        stop:=1
        repeat until stop==0
        waitcnt(cnt+clkfreq>>2)
        playcog:=cognew(playcmd,@playstack)


      vga.outtextxy(2,22,string("Playing file: "))
      vga.outtextxy(4,23,string("                                "))
      vga.outtextxy(2,24,string("File type: "))
      vga.outtextxy(4,25,string("Commodore C64 SID dump file"))
      vga.outtextxy(2,26,string("Playing frequency: "))
      vga.outtextxy(4,27,string("           "))
      vga.outtextxy(4,27,vga.inttostr(namebuf[32*pos+14]))
      vga.outtextxy(4+strsize(vga.inttostr(namebuf[32*pos+14])),27,string(" Hz "))
      vga.outtextxy(4,23,@namebuf+32*pos+15)

pub displaytime(time2) | secs,minss,hs

  secs:=(time2/100000)//60
  minss:=(time2/6000000)//60
  hs:=time2/360000000
  if hs<10
    vga.putchar(16,28,"0")
    vga.putchar(17,28,48+hs)
  else
    vga.outtextxy(16,28,vga.inttostr(hs))

  if minss<10
    vga.putchar(19,28,"0")
    vga.putchar(20,28,48+minss)
  else
    vga.outtextxy(19,28,vga.inttostr(minss))


  if secs<10
    vga.putchar(22,28,"0")
    vga.putchar(23,28,48+secs)
  else
    vga.outtextxy(22,28,vga.inttostr(secs))




pub setdmpdisplay(a)|  i,x,y

x:=11
y:=disp_pos+4
repeat i from 0 to 7
  vga.setfontcolor(y,i+x,2,3,3)
  vga.setbackcolor(y,i+x,1,0,0)


if (pos+a)>il
  a:=il-pos
if (pos+a)<0
  a:=-pos

pos+=a 'set new list position


if (disp_pos+a)>-1 and (disp_pos+a)<24
  disp_pos+=a

else
  if disp_pos+a>23
    disp_start:=pos-23
    display
    disp_pos:=23

  if disp_pos+a<0
    disp_start:=pos
    display
    disp_pos:=0

x:=11
y:=disp_pos+4
repeat i from 0 to 7
  vga.setfontcolor(y,i+x,0,0,2)
  vga.setbackcolor(y,i+x,2,1,1)



pub display |l,x,y,i


repeat i from disp_start to disp_start+23
  l:=strsize(@namebuf+32*i+15)
  x:=60-(l+1)/2
  y:=i+4-disp_start
  vga.outtextxy(41,y,string("                              "))
  vga.outtextxy(x,y,@namebuf+32*i+15)


pub playcmd |c,i,w

stop:=0
\fat.openfile(@namebuf+32*pos,"r")
playrate:=namebuf[32*pos+14]
w:=clkfreq/playrate
c:=fat.readdata(@buffer2,25)
if c<>25
  vga.outtextxy(4,22,string("File not found"))
  return
time:=0
wait:=cnt
repeat
  wait:=wait+w
  ifnot (cnt>0) and (wait<0)
    repeat until cnt>wait
  else
    repeat until cnt<0
    repeat until cnt>wait
  c:=fat.readdata(@buffer2,25)
  sid.updateRegisters(@buffer2)
  time:=time+100000/playrate
until (c<>25) or (stop==1)
fat.closefile
bytefill(@buffer2,0,25)
sid.updateRegisters(@buffer2)
stop:=0
c:=playcog
playcog:=-1
cogstop(c)



pub  scan|i,buffer,c,freq,l

i:=0

\fat.listEntries("W")
repeat while(buffer := \fat.listEntries("N"))
  l:=11
  repeat while byte[buffer+l]==32
    byte[buffer+l]:=0
    l-=1
  l:=strsize(buffer)
  if strcomp(buffer+l-4,string(".DMP"))
    bytemove(@namebuf+(32*i),buffer,13)
    \fat.openfile(buffer,"r")
    c:=\fat.readdata(@buffer2,25)
    if c==25
      if (buffer2[0]=="S") and (buffer2[1]=="D") and (buffer2[2]=="M") and (buffer2[3]=="P")
        freq:=buffer2[4]
        namebuf[32*i+14]:=freq
        bytemove(@namebuf+32*i+15,@buffer2+8,16)
      else
        byte[buffer+l-4]:=0
        bytemove(@namebuf+32*i+15,buffer,l)
        namebuf[32*i+14]:=50
      i:=i+1
      vga.outtextxy(45,1,vga.inttostr(i))
    if i>299
      quit

vga.outtextxy(34,1, string("                  "))
result:=i


